<template>
  <div class="barcas">
    <header>
      <h2>Barcas</h2>
      <div class="buttons">
        <button class="circle" :class="{ loading }" @click="refrescar">
          <LoadingIcono />
        </button>
        <router-link tag="button" class="circle primary" to="/barcas/crear"
          ><InIcono
        /></router-link>
      </div>
    </header>
    <!-- TODO: poner en <header> -->
    <nav class="inline-nav" v-if="!sinBarcas">
      <a
        href="#"
        :class="{ active: filtro === Filtros.ABORDADAS }"
        @click.prevent="e => (prefFiltro = Filtros.ABORDADAS)"
        >Abordadas</a
      >
      <a
        href="#"
        :class="{ active: filtro === Filtros.A_ABORDAR }"
        @click.prevent="e => (prefFiltro = Filtros.A_ABORDAR)"
        >A abordar</a
      >
    </nav>
    <div
      class="lista-barcas"
      v-if="barcasFiltradas && barcasFiltradas.length > 0"
    >
      <barca
        :barca="barca"
        :key="barca.id"
        :borderColor="colors[index % colors.length]"
        :updateKey="updateKey"
        v-for="(barca, index) in barcasFiltradas"
      />
    </div>
    <div class="lista-barcas" v-else-if="barcasFiltradas">
      <template v-if="filtro === Filtros.ABORDADAS">
        No abordaste ninguna barca.
      </template>
      <template v-else>
        Ya estas en todas las barcas :)
      </template>
    </div>
    <template v-else-if="error"> Error: {{ error }} </template>
    <template v-else-if="loading">
      Cargando...
    </template>
  </div>
</template>

<script>
import { mapState } from 'vuex'

import InIcono from '@/assets/iconos/in.svg?inline'
import LoadingIcono from '@/assets/iconos/loading.svg?inline'
import Barca from '@/components/Barca'

const Filtros = { ABORDADAS: 1, A_ABORDAR: 2 }

export default {
  name: 'BarcasView',
  components: { InIcono, LoadingIcono, Barca },
  data() {
    return {
      error: null,
      loading: true,
      updateKey: 0,
      Filtros,
      prefFiltro: Filtros.ABORDADAS,
      colors: [
        '#ab4642',
        '#dc9656',
        '#f7ca88',
        '#61EF94',
        '#6FBEFB',
        '#9063E9',
      ],
    }
  },
  computed: {
    ...mapState(['barcas']),
    barcasFiltradas() {
      return (
        this.barcas.length > 0 &&
        this.barcas
          .filter(({ abordada }) =>
            this.filtro === Filtros.ABORDADAS ? abordada : !abordada,
          )
          .sort((a, b) => new Date(a.created_at) - new Date(b.created_at))
      )
    },
    filtro() {
      return this.sinBarcas ? Filtros.A_ABORDAR : this.prefFiltro
    },
    sinBarcas() {
      const barcasAbordadas = this.barcas.filter(({ abordada }) => abordada)
      return barcasAbordadas.length < 1
    },
  },
  methods: {
    refrescar() {
      this.error = null
      this.loading = true
      this.updateKey = ++this.updateKey
      return this.$store
        .dispatch('conseguirTodasLasBarcas')
        .catch(error => (this.error = error))
        .finally(() => {
          this.loading = false
        })
    },
  },
  watch: {
    filtro() {
      this.refrescar()
    },
  },
  mounted() {
    // fetch data
    this.refrescar()
  },
}
</script>

<style lang="sass" scoped>
.barcas
  margin: 0 20px
.lista-barcas
  margin-bottom: 20px
.inline-nav
  margin-bottom: 20px
</style>
